'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _styles = require('./styles');

var Flex = function Flex(_ref) {
  var wrap = _ref.wrap;
  var column = _ref.column;
  var align = _ref.align;
  var justify = _ref.justify;
  var gutter = _ref.gutter;
  var sm = _ref.sm;
  var md = _ref.md;
  var lg = _ref.lg;
  var stretch = _ref.stretch;
  var style = _ref.style;

  var props = _objectWithoutProperties(_ref, ['wrap', 'column', 'align', 'justify', 'gutter', 'sm', 'md', 'lg', 'stretch', 'style']);

  var display = undefined;

  if (typeof window !== 'undefined') {
    if (sm && window.matchMedia(_styles.breakpoints.sm).matches) {
      display = 'flex';
    } else if (md && window.matchMedia(_styles.breakpoints.md).matches) {
      display = 'flex';
    } else if (lg && window.matchMedia(_styles.breakpoints.lg).matches) {
      display = 'flex';
    } else if (sm || md || lg) {
      display = 'block';
    } else {
      display = 'flex';
    }
  } else {
    display = 'flex';
  }

  var sx = Object.assign({}, style, {
    display: display,
    flexWrap: wrap ? 'wrap' : null,
    flexDirection: column ? 'column' : null,
    flex: stretch ? '1 1 auto' : null,
    alignItems: align || null,
    justifyContent: justify || null,
    marginLeft: gutter ? -_styles.scale[gutter] : null,
    marginRight: gutter ? -_styles.scale[gutter] : null
  });

  return _react2['default'].createElement('div', _extends({}, props, {
    style: sx,
    className: 'Flex' }));
};

var _React$PropTypes = _react2['default'].PropTypes;
var bool = _React$PropTypes.bool;
var oneOf = _React$PropTypes.oneOf;

Flex.propTypes = {
  wrap: bool,
  column: bool,
  sm: bool,
  md: bool,
  lg: bool,
  gutter: oneOf([0, 1, 2, 3, 4]),
  align: oneOf(['stretch', 'center', 'baseline', 'flex-start', 'flex-end']),
  justify: oneOf(['center', 'space-around', 'space-between', 'flex-start', 'flex-end']),
  stretch: bool
};

Flex.defaultProps = {
  style: {}
};

exports['default'] = Flex;
module.exports = exports['default'];